# Introduction

Introduction to the m17n library. More...

## Defines

#define | M17NLIB_MAJOR_VERSION
#define | M17NLIB_MINOR_VERSION
#define | M17NLIB_PATCH_LEVEL
#define | M17NLIB_VERSION_NAME
#define | M17N_INIT()
| Initialize the m17n library.
#define | M17N_FINI()
| Finalize the m17n library.

## Enumerations

enum | M17NStatus { M17N_NOT_INITIALIZED, M17N_CORE_INITIALIZED, M17N_SHELL_INITIALIZED, M17N_GUI_INITIALIZED }
| Enumeration for the status of the m17n library. More...

## Functions

enum M17NStatus | m17n_status (void)
| Report which part of the m17n library is initialized.

## Detailed Description

Introduction to the m17n library.

API LEVELS

The API of the m17n library is divided into these five.

1. CORE API

   It provides basic modules to handle M-texts. To use this API, an application program must include <m17n-core.h> and be linked with -lm17n-core.

2. SHELL API

   It provides modules for character properties, character set handling, code conversion, etc. They load various kinds of data from the database on demand. To use this API, an application program must include <m17n.h> and be linked with -lm17n-core -lm17n.

   When you use this API, CORE API is also available.

3. FLT API

   It provides modules for text shaping using Font Layout Table. To use this API, an application program must include <m17n.h> and be linked with -lm17n-core -lm17n-flt.

   When you use this API, CORE API is also available.

4. GUI API

   It provides GUI modules such as drawing and inputting M-texts on a graphic device. This API itself is independent of graphic devices, but most functions require an argument MFrame that is created for a specific type of graphic devices. The currently supported graphic devices are null device, the X Window System, and image data (gdImagePtr) of the GD library.

   On a frame of a null device, you cannot draw text nor use input methods. However, functions like mdraw_glyph_list(), etc. are available.

   On a frame of the X Window System, you can use the whole GUI API.

   On a frame of the GD library, you can use all drawing API but cannot use input methods.

   To use this API, an application program must include <m17n-gui.h> and be linked with -lm17n-core -lm17n -lm17n-gui.

   When you use this API, CORE, SHELL, and FLT APIs are also available.

5. MISC API

   It provides miscellaneous functions to support error handling and debugging. This API cannot be used standalone; it must be used with one or more APIs listed above. To use this API, an application program must include <m17n-misc.h> in addition to one of the header files described above.

See also the section m17n-config(1).

ENVIRONMENT VARIABLES

The m17n library pays attention to the following environment variables.

- `M17NDIR`

  The name of the directory that contains data of the m17n database. See Database for details.

- `MDEBUG_XXX`

  Environment variables whose names start with "MDEBUG_" control debug information output. See Debugging for details.

API NAMING CONVENTION

The m17n library exports functions, variables, macros, and types. All of them start with the letter 'm' or 'M', and are followed by an object name (e.g. "symbol", "plist") or a module name (e.g. draw, input). Note that the name of M-text objects start with "mtext" and not with "mmtext".

- functions -- mobject() or mobject_xxx()

  They start with 'm' and are followed by an object name in lower case. Words are separated by '_'. For example, msymbol(), mtext_ref_char(), mdraw_text().

- non-symbol variables -- mobject, or mobject_xxx

  The naming convention is the same as functions (e.g. mface_large).

- symbol variables -- Mname

  Variables of the type MSymbol start with 'M' and are followed by their names. Words are separated by '_'. For example, Mlanguage (the name is "language"), Miso_2022 (the name is "iso-2022").

- macros -- MOBJECT_XXX

  They start with 'M' and are followed by an object name in upper case. Words are separated by '_'.

- types -- MObject or MObjectXxx

  They start with 'M' and are followed by capitalized object names. Words are concatenated directly and no '_' are used. For example, MConverter, MInputDriver.

## Define Documentation

#define M17NLIB_MAJOR_VERSION

The M17NLIB_MAJOR_VERSION macro gives the major version number of the m17n library.

#define M17NLIB_MINOR_VERSION

The M17NLIB_MINOR_VERSION macro gives the minor version number of the m17n library.

#define M17NLIB_PATCH_LEVEL

The M17NLIB_PATCH_LEVEL macro gives the patch level number of the m17n library.

#define M17NLIB_VERSION_NAME

The M17NLIB_VERSION_NAME macro gives the version name of the m17n library as a string.

#define M17N_INIT | ( |  | ) |

Initialize the m17n library.

The macro M17N_INIT() initializes the m17n library. This macro must be called before any m17n functions are used.

It is safe to call this macro multiple times, but in that case, the macro M17N_FINI() must be called the same times to free the memory.

If the initialization was successful, the external variable merror_code is set to 0. Otherwise it is set to -1.

See Also:
  M17N_FINI(), m17n_status()

#define M17N_FINI | ( |  | ) |

Finalize the m17n library.

The macro M17N_FINI() finalizes the m17n library. It frees all the memory area used by the m17n library. Once this macro is called, no m17n functions should be used until the macro M17N_INIT() is called again.

If the macro M17N_INIT() was called N times, the Nth call of this macro actually free the memory.

See Also:
  M17N_INIT(), m17n_status()

## Enumeration Type Documentation

enum M17NStatus

Enumeration for the status of the m17n library.

The enum M17NStatus is used as a return value of the function m17n_status().

Enumerator:

  M17N_NOT_INITIALIZED | No modules is initialized, and all modules are finalized.
  M17N_CORE_INITIALIZED | Only the modules in CORE API are initialized.
  M17N_SHELL_INITIALIZED | Only the modules in CORE and SHELL APIs are initialized.
  M17N_GUI_INITIALIZED | All modules are initialized.

## Function Documentation

enum M17NStatus m17n_status | ( | void |  | ) |

Report which part of the m17n library is initialized.

The m17n_status() function returns one of these values depending on which part of the m17n library is initialized:

M17N_NOT_INITIALIZED, M17N_CORE_INITIALIZED, M17N_SHELL_INITIALIZED, M17N_GUI_INITIALIZED

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines